module PDF
  implicit none

  integer :: hadron1 = 1, hadron2 = 1
  real(8) :: mu_f

contains

!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!

! fg_gen generate the derivatives of the gluon PDF

  subroutine fg_gen(x, n, f)
    implicit none
    real(8), intent(in) :: x
    integer, intent(in) :: n
    real(8), intent(out) :: f(0:2)
    real(8) :: h, fp, fm
    real(8) :: pdf(-6:6)

    call evolvePDF(x, mu_f, pdf)
    f(0) = pdf(0)/x
    if (n > 1) then
       h = x*1d-6
       call evolvePDF(x+h, mu_f, pdf)
       fp = pdf(0)/(x+h)
       call evolvePDF(x-h, mu_f, pdf)
       fm = pdf(0)/(x-h)
       f(1) = (fp - fm) / (2d0*h)
       f(2) = (fp - 2d0*f(0) + fm) / h**2
    endif
  end subroutine fg_gen

end module PDF
